      subroutine ecrit(x,h1,q1,h2,q2,h3,q3,h4,q4,t,i)
      IMPLICIT NONE
      INCLUDE 'common.inc' 
      double precision x(*),t
      DOUBLE PRECISION h1(*)
      DOUBLE PRECISION h2(*)
      DOUBLE PRECISION h3(*)
      DOUBLE PRECISION h4(*)

      DOUBLE PRECISION q1(*)
      DOUBLE PRECISION q2(*)
      DOUBLE PRECISION q3(*)
      DOUBLE PRECISION q4(*)
      DOUBLE PRECISION hh,uu

      DOUBLE PRECISION Z
      EXTERNAL Z
C NE PAS TOUCHER
C***********************************************************************************************************************
      INTEGER NNN,INDEX,J,Ra(1:1000),QU
      INTEGER DIR1,DIR2,INDEXMAX,I,K,YFILE
      CHARACTER*72 NUMERO,TMP,NOM1
      CHARACTER    VIRG,BACK
C***********************************************************************************************************************
      VIRG= ',' 
      BACK='\\'
      INDEXMAX = 10
c
c Decomposition d'un entier en decimale.
c
      NNN   = I
      INDEX = 1
c
10    IF(NNN .LT. 10) THEN
         Ra(INDEX)=NNN
      ELSE
        QU = NNN / 10
        Ra(INDEX) = NNN-10 * QU
        NNN = QU
        INDEX = INDEX + 1
        GO TO 10
      ENDIF
      DO 15 J=INDEX+1,INDEXMAX
           Ra(J) = 0
15    CONTINUE
c
c Transcription des decimales en caracteres
c
      NUMERO(1:1) = CHAR(ICHAR('0')+Ra(INDEXMAX))
      DO 20 J = 2,INDEXMAX
        K= J - 1
        TMP(1:J)=NUMERO(1:K)//CHAR(ICHAR('0')+Ra(INDEXMAX-J+1))
        NUMERO = TMP
 20   CONTINUE
c
c L'entier est maintenant en caracteres.
c
c Ouverture des fichiers ou sont stockee y et u
c
      NOM1     = 'sources/data/tmp.'//NUMERO(1:INDEXMAX)
      OPEN(11,FILE=NOM1)	
      DIR1 = 17
c
c On prepare les fichiers Gnuplot; on rajoute des guillemets aux noms de fichiers
c
      NOM1   = '"'//NOM1(1:INDEXMAX+DIR1)//'"'
c
c Remplissage des fichiers gnuplot ou une seule courbe est tracee et on attend une seconde.
c
      DIR1 = DIR1 + 2


c
c Ecriture de la hauteur d'eau dans le fichier h.plt
c
      WRITE(1,98) ABS(t)
98    FORMAT('set title "T = ',F8.3)
      WRITE(1,*) 'set ylabel  "h"  font "Times-Roman, 18' 


      WRITE(1,*) 'plot ',NOM1(1:INDEXMAX+DIR1),
     & '    u 1:2 w l lw 3 title "h (Godunov)",',
     & ' "" u 1:3 w l lw 3 title "h (Cinetique)",',
     & ' "" u 1:4 w l lw 3 title "h (L-F)",',
     & ' "" u 1:5 w l lw 3 title "h (Rusanov)",',
     & ' "" u 1:11 w l lw 3 title "h (Exacte)",',
     & ' "" u 1:10 w l lt -1 lw 3 title "Z"'
      IF (i.EQ.0) THEN 
        WRITE(1,*) 'pause -1 "Hit return to continue"'
      ENDIF
c
c Ecriture du debit d'eau dans le fichier q.plt
c
      WRITE(2,98) ABS(t)
      WRITE(2,*) 'set ylabel  "q"  font "Times-Roman, 18' 
      WRITE(2,*) 'plot ',NOM1(1:INDEXMAX+DIR1),
     & '    u 1:6 w l lw 3 title "q (Godunov)",',
     & ' "" u 1:7 w l lw 3 title "q (Cinetique)",',
     & ' "" u 1:8 w l lw 3 title "q (L-F)",',
     & ' "" u 1:9 w l lw 3 title "q (Rusanov)",',
     & ' "" u 1:12 w l lw 3 title "q (Exacte)"'
      IF (i.EQ.0) THEN 
        WRITE(2,*) 'pause -1 "Hit return to continue"'
      ENDIF
c On ecrit dans les fichiers 
c
      DO J = 1,N+1
c Solution analytique (hh,hh*uu)
        call riemann((x(J)-z0)/t,hl,ql/hl,hr,qr/hr,hh,uu)
        WRITE(11,*) x(J),h1(J)+Z(x(j)),h2(J)+Z(x(j)),h3(J)+Z(x(j)),
     &  h4(J)+Z(x(j)),
     &  q1(J),q2(J),q3(J),q4(J),Z(x(j)),hh,hh*uu 
        WRITE(11,*) x(J+1),h1(J)+Z(x(j)),h2(J)+Z(x(j)),h3(J)+Z(x(j)),
     &  h4(J)+Z(x(j)),
     &  q1(J),q2(J),q3(J),q4(J),Z(x(j)),hh,hh*uu 
      ENDDO

      RETURN
      END

